{
  Copyright (c) 2001 by Adam Boduch
  http://programowanie.of.pl
  E - mail: boduch@poland.com
  27.05.2001 r.
}                                              

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    rgOptions: TRadioGroup;
    edtText: TEdit;
    btnGo: TButton;
    procedure btnGoClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure DrawAnim(X, Y : Integer);
    procedure SteepBySteep(X, Y : Integer);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

var
  DText : String; // tekst, ktory bedzie wyswietlony na formie
  Done : Boolean; // jezeli TRUE to animacja jest zakonczona

procedure TMainForm.DrawAnim(X, Y: Integer);
var
  B : TBitmap; // Bitmapa
  i : Integer;
begin
  B := TBitmap.Create; // utwrz bitmape
  B.Height := 40;  // wysokosc bitmapy
  B.Width := Canvas.TextWidth(Text) * 10; // szerokosc bitmapy
  B.Canvas.Font.Name := 'Courier New';  // czcionka
  B.Canvas.Font.Size := 14; // rozmiar czcionki
  B.Canvas.Brush.Color := Color; // kolor tla
// stworz obszar na ktorym bitmapa ma byc wyswietlana
  B.Canvas.FillRect(Rect(0, 0, Canvas.TextWidth(Text) * 10, 40));

  while not (Done) do // Jezeli Done = False...
  begin // zacznij odtwarzanie animacji
    for i:= X to Width  do  // zacznij od punktu X to konca formy
    begin
      Application.ProcessMessages; // daj odetchnac systemowi
      Sleep(10); // czekaj 1 milisekunde
      B.Canvas.Font.Color := clWhite; // kolor na bialy
      B.Canvas.TextOut(10, 10, DText); // wyswietlenie tekstu
      B.Canvas.Brush.Style := bsClear; // tlo na przezroczyste
      B.Canvas.Font.Color := clBlack; // kolor czcionki: czarny
      B.Canvas.TextOut(9, 9, DText); // wyswietl tekst jeszcze raz
      Canvas.Draw(I, Y, B); // wyswiet bitmape
      if (Done) then // Jezeli ktos przerwal animacje ( Done = True )...
        Break; // ... to przerwij odtwarzanie animacji
    end;
  end;
  B.Free; // zwolnji pamiec dla zmiennej
end;


procedure TMainForm.SteepBySteep(X, Y: Integer);
var
  TextLength, I: Integer;
begin
  Done := TRUE; // zkoncz poprzednia animacje
  TextLength := Length(DText); // pobierz dlugosc tekstu

  with Canvas do
  begin
    for I := 1 to TextLength do // petelka...
    begin
      Application.ProcessMessages;
      Sleep(100);  // czkeja 100 milisekund
      Brush.Style := bsClear; // styl na przezroczysty
      Font.Name := 'Courier New'; // czcionka
      Font.Color := clWhite; // kolor czcionki - bialy
      Font.Size := 16;  // rozmiar
{ Wyswietlaj tekst jedna litera po drugiej z przesunieciem }
      TextOut((X + i * 16), Y, DText[i]);
      Brush.Style := bsClear;
      Font.Color :=  clBlack;
      TextOut((X + i * 16) -2, Y -2, DText[i]); // wyswietl ten sam tekst w innym polozeniu - efekt cienia
   end;
  end;
end;

procedure TMainForm.btnGoClick(Sender: TObject);
begin
  DText := edtText.Text; // przypisz do zmiennej tekst z komponentu

  case rgOptions.ItemIndex of
    0: DrawAnim(0, 100);
    1: SteepBySteep(10, 100);
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Done := TRUE; // przy zamykaniu zmien wartosc
end;

end.
